### Eclipse Workspace Patch 1.0
#P org.jboss.tools.deltacloud.core
Index: src/org/jboss/tools/deltacloud/core/ICloudElementFilter.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/ICloudElementFilter.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/ICloudElementFilter.java	(working copy)
@@ -12,9 +12,9 @@
 
 import java.util.Collection;
 
-
 /**
- * A filter interface that may be applied on IDeltaCloudElement. Known implementors are IImageFilter and IInstanceFilter
+ * A filter interface that may be applied on IDeltaCloudElement. Known
+ * implementors are IImageFilter and IInstanceFilter
  * 
  * @see IDeltaCloudElement
  * @see IImageFilter
@@ -29,17 +29,11 @@
 
 	public static final String ALL_MATCHER_EXPRESSION = "*"; //$NON-NLS-1$
 
-	public static final String ALL_STRING =
-			ALL_MATCHER_EXPRESSION + EXPRESSION_DELIMITER // name
-					+ ALL_MATCHER_EXPRESSION + EXPRESSION_DELIMITER // id
-					+ ALL_MATCHER_EXPRESSION + EXPRESSION_DELIMITER // arch
-					+ ALL_MATCHER_EXPRESSION; // desc
-
 	public Collection<CLOUDELEMENT> filter(CLOUDELEMENT[] cloudElements) throws DeltaCloudException;
 
-	public void setRules(String ruleString);
-
 	public IFieldMatcher getNameRule();
 
 	public IFieldMatcher getIdRule();
+
+	public boolean isFiltering();
 }
Index: src/org/jboss/tools/deltacloud/core/job/LoadCloudInstancesJob.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/job/LoadCloudInstancesJob.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/job/LoadCloudInstancesJob.java	(revision 0)
@@ -0,0 +1,29 @@
+package org.jboss.tools.deltacloud.core.job;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.jboss.tools.deltacloud.core.DeltaCloud;
+
+public class LoadCloudInstancesJob extends AbstractCloudElementJob {
+
+	private DeltaCloud cloud;
+	private Runnable post = null;
+	public LoadCloudInstancesJob(DeltaCloud cloud) {
+		super("Loading Cloud Instances for cloud " + cloud.getName(), 
+				cloud, CLOUDELEMENT.INSTANCES);
+		this.cloud = cloud;
+	}
+	public LoadCloudInstancesJob(DeltaCloud cloud, Runnable post) {
+		this(cloud);
+		this.post = post;
+	}
+
+	@Override
+	protected IStatus doRun(IProgressMonitor monitor) throws Exception {
+		cloud.loadInstances();
+		if( post != null ) 
+			post.run();
+		return Status.OK_STATUS;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/client/unmarshal/InstanceUnmarshaller.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/unmarshal/InstanceUnmarshaller.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/unmarshal/InstanceUnmarshaller.java	(working copy)
@@ -13,10 +13,10 @@
 import java.util.ArrayList;
 import java.util.List;
 
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.AddressList;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.Instance;
-import org.jboss.tools.deltacloud.core.client.InstanceAction;
 import org.w3c.dom.Element;
 import org.w3c.dom.Node;
 import org.w3c.dom.NodeList;
@@ -24,7 +24,7 @@
 /**
  * @author André Dietisheim
  */
-public class InstanceUnmarshaller extends AbstractActionAwareUnmarshaller<Instance, InstanceAction> {
+public class InstanceUnmarshaller extends AbstractActionAwareUnmarshaller<Instance> {
 
 	public InstanceUnmarshaller() {
 		super("instance", Instance.class, "link");
@@ -79,9 +79,9 @@
 	}
 
 	@Override
-	protected InstanceAction unmarshallAction(Element element) throws DeltaCloudClientException {
-		InstanceAction action = new InstanceAction();
-		new InstanceActionUnmarshaller().unmarshall(element, action);
+	protected Action<Instance> unmarshallAction(Element element) throws DeltaCloudClientException {
+		Action<Instance> action = new Action<Instance>();
+		new ActionUnmarshaller<Instance>().unmarshall(element, action);
 		return action;
 	}
 }
Index: ChangeLog
===================================================================
--- ChangeLog	(revision 29286)
+++ ChangeLog	(working copy)
@@ -1,3 +1,47 @@
+2011-02-18  André Dietisheim  <André Dietisheim@adietisheim-thinkpad>
+
+	* src/org/jboss/tools/deltacloud/core/DeltaCloudManager.java 
+	(loadCloud): 
+	(printCloud): 
+	* src/org/jboss/tools/deltacloud/core/DeltaCloud.java 
+	(lastRealmName): 
+	(lastProfileId): 
+	(setLastProfileId): 
+	(getLastProfileId): 
+	(getLastRealmName): 
+	(setLastRealmName): 
+	[JBIDE-8333]
+
+2011-02-15  André Dietisheim  <André Dietisheim@adietisheim-thinkpad>
+
+	* src/org/jboss/tools/deltacloud/core/DeltaCloud.java (update): 
+	[JBIDE-8420] storing credentials before loading children 
+	(was: loaded children and stored afterwards. storing was skipped since loading threw an exception)
+
+2011-02-07  André Dietisheim  <André Dietisheim@adietisheim-thinkpad>
+
+	* src/org/jboss/tools/deltacloud/core/DeltaCloud.java (waitForState): 
+	[JBIDE-8343] increased wait delay for refreshing instance, waiting before refreshing (was: refreshed first and waited afterwards)
+
+2011-02-03  André Dietisheim  <André Dietisheim@adietisheim-thinkpad>
+
+	* src/org/jboss/tools/deltacloud/core/ImageFilter.java: 
+	* src/org/jboss/tools/deltacloud/core/InstanceFilter.java: 
+	* src/org/jboss/tools/deltacloud/core/AbstractCloudElementFilter.java:
+	[JBIDE-8187] added capability to filter for instance alias 
+
+2011-01-27  André Dietisheim  <André Dietisheim@adietisheim-thinkpad>
+
+	* src/org/jboss/tools/deltacloud/core/client/DeltaCloudClientImpl.java (getServerType): 
+	* src/org/jboss/tools/deltacloud/core/DeltaCloud.java (getDriver): 
+	[JBIDE-8250] 
+	- renamed Driver to DeltaCloudDriver, renamed ServerType to Driver
+	- moved driver unmarshalling to APIUnmarshaller
+	- added tests for APIUnmarshaller
+	* src/org/jboss/tools/deltacloud/core/client/HttpStatusCode.java (UNAUTHORIZED): 
+	* src/org/jboss/tools/deltacloud/core/client/DeltaCloudClientImpl.java (throwOnHttpErrors): 
+	[JBIDE-8250] authorization error is status code 401 (was: 403)
+	
 2011-01-11  André Dietisheim  <André Dietisheim@adietisheim-thinkpad>
 
 	* src/org/jboss/tools/deltacloud/core/client/DeltaCloudClientImpl.java 
Index: src/org/jboss/tools/deltacloud/core/client/Instance.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/Instance.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/Instance.java	(working copy)
@@ -10,27 +10,18 @@
  *******************************************************************************/
 package org.jboss.tools.deltacloud.core.client;
 
-import java.util.ArrayList;
 import java.util.List;
 
-import javax.xml.bind.annotation.XmlElement;
-
 /**
  * @author Martyn Taylor
  * @author Andre Dietisheim
  */
-public class Instance extends AbstractDeltaCloudActionAwareObject<InstanceAction> {
+public class Instance extends StateAware<Instance> {
 
 	private static final long serialVersionUID = 1L;
 
-	public static enum InstanceState {
-		RUNNING, STOPPED, PENDING, TERMINATED, BOGUS
-	};
-
-	@XmlElement(name = "owner_id")
 	private String ownerId;
 
-	@XmlElement
 	private String name;
 
 	private String imageId;
@@ -47,13 +38,8 @@
 
 	private String keyId;
 
-	@XmlElement
-	private InstanceState state;
-
-	@XmlElement(name = "public_addresses")
 	private AddressList publicAddresses;
 
-	@XmlElement(name = "private_addresses")
 	private AddressList privateAddresses;
 
 	public Instance() {
@@ -91,14 +77,6 @@
 		this.realmId = realmId;
 	}
 
-	public void setState(String state) {
-		try {
-			this.state = InstanceState.valueOf(state);
-		} catch (Exception e) {
-			this.state = InstanceState.BOGUS;
-		}
-	}
-
 	public void setKeyId(String keyId) {
 		this.keyId = keyId;
 	}
@@ -147,51 +125,6 @@
 		return realmId;
 	}
 
-	public InstanceState getState() {
-		return state;
-	}
-
-	public List<String> getActionNames() {
-		ArrayList<String> names = new ArrayList<String>();
-		for (InstanceAction action : getActions()) {
-			names.add(action.getName());
-		}
-		return names;
-	}
-
-	public InstanceAction getAction(String name) {
-		if (name == null) {
-			return null;
-		}
-
-		for (InstanceAction action : getActions()) {
-			if (name.equals(action.getName())) {
-				return action;
-			}
-		}
-		return null;
-	}
-
-	public boolean canStart() {
-		return getAction(IInstanceAction.START) != null;
-	}
-
-	public boolean canStop() {
-		return getAction(IInstanceAction.STOP) != null;
-	}
-
-	public boolean canReboot() {
-		return getAction(IInstanceAction.REBOOT) != null;
-	}
-
-	public boolean canDestroy() {
-		return getAction(InstanceAction.DESTROY) != null;
-	}
-
-	public boolean isRunning() {
-		return getState() == InstanceState.RUNNING;
-	}
-
 	public List<String> getPublicAddresses() {
 		return publicAddresses.getAddress();
 	}
@@ -200,22 +133,6 @@
 		return privateAddresses.getAddress();
 	}
 
-	public boolean start(DeltaCloudClient client) throws DeltaCloudClientException {
-		return ((InternalDeltaCloudClient) client).performInstanceAction(getAction(IInstanceAction.START));
-	}
-
-	public boolean stop(DeltaCloudClient client) throws DeltaCloudClientException {
-		return ((InternalDeltaCloudClient) client).performInstanceAction(getAction(IInstanceAction.STOP));
-	}
-
-	public boolean destroy(DeltaCloudClient client) throws DeltaCloudClientException {
-		return ((InternalDeltaCloudClient) client).performInstanceAction(getAction(InstanceAction.DESTROY));
-	}
-
-	public boolean reboot(DeltaCloudClient client) throws DeltaCloudClientException {
-		return ((InternalDeltaCloudClient) client).performInstanceAction(getAction(IInstanceAction.REBOOT));
-	}
-
 	@Override
 	public String toString() {
 		String s = "";
@@ -234,7 +151,7 @@
 		}
 		s += "State:\t\t" + getState() + "\n";
 
-		List<InstanceAction> actions = getActions();
+		List<Action<Instance>> actions = getActions();
 		if (actions != null) {
 			for (int i = 0; i < actions.size(); i++) {
 				if (i == 0) {
Index: src/org/jboss/tools/deltacloud/core/client/request/PerformActionRequest.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/request/PerformActionRequest.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/request/PerformActionRequest.java	(revision 0)
@@ -0,0 +1,47 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core.client.request;
+
+import org.jboss.tools.deltacloud.core.client.Action;
+import org.jboss.tools.deltacloud.core.client.HttpMethod;
+import org.jboss.tools.deltacloud.core.client.utils.UrlBuilder;
+
+/**
+ * Performs an action on a resource of the deltacloud server. The typical
+ * actions are
+ * <ul>
+ * <li>START</li>
+ * <li>STOP</li>
+ * <li>DESTROY</li>
+ * <li>REBOOT</li>
+ * </ul>
+ * 
+ * @author André Dietisheim
+ * 
+ * @see Action
+ */
+public class PerformActionRequest extends AbstractDeltaCloudRequest {
+
+	public PerformActionRequest(String url, HttpMethod httpMethod) {
+		super(url, httpMethod);
+	}
+
+	@Override
+	protected String doCreateUrl(UrlBuilder urlBuilder) {
+		return urlBuilder.toString();
+	}
+
+	@Override
+	protected UrlBuilder createUrlBuilder(String baseURL) {
+		return new UrlBuilder(baseURL);
+	}
+
+}
Index: src/org/jboss/tools/deltacloud/core/client/DeltaCloudClient.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/DeltaCloudClient.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/DeltaCloudClient.java	(working copy)
@@ -12,7 +12,7 @@
 
 import java.util.List;
 
-import org.jboss.tools.deltacloud.core.client.DeltaCloudClientImpl.DeltaCloudServerType;
+import org.jboss.tools.deltacloud.core.client.API.Driver;
 
 /**
  * @author Martyn Taylor
@@ -27,7 +27,7 @@
 	 * 
 	 * @see DeltaCloudServerType
 	 */
-	public DeltaCloudServerType getServerType();
+	public Driver getServerType();
 
 	/**
 	 * Returns a list of Delta Cloud Realms
@@ -134,14 +134,6 @@
 	public Key createKey(String keyname) throws DeltaCloudClientException;
 
 	/**
-	 * Deletes the key with the given name on the deltacloud server
-	 * 
-	 * @param keyname
-	 * @throws DeltaCloudClientException
-	 */
-	public void deleteKey(String keyname) throws DeltaCloudClientException;
-
-	/**
 	 * Lists all keys available on the deltacloud server this client is
 	 * connected to.
 	 * 
@@ -156,4 +148,14 @@
 	 * Throws a DeltaCloudException if it is not available.
 	 */
 	public Key listKey(String id) throws DeltaCloudClientException;
+	
+	/**
+	 * Performs the given action.
+	 *
+	 * @param action the action to execute
+	 * @return true, if successful
+	 * 
+	 * @see Action
+	 */
+	public boolean performAction(Action<?> action) throws DeltaCloudClientException;
 }
Index: src/org/jboss/tools/deltacloud/core/IInstanceFilter.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/IInstanceFilter.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/IInstanceFilter.java	(working copy)
@@ -16,6 +16,7 @@
  */
 public interface IInstanceFilter extends ICloudElementFilter<DeltaCloudInstance> {
 	
+	public IFieldMatcher getAliasRule();
 	public IFieldMatcher getImageIdRule();
 	public IFieldMatcher getOwnerIdRule();
 	public IFieldMatcher getKeyNameRule();
Index: src/org/jboss/tools/deltacloud/core/client/unmarshal/AbstractDOMUnmarshaller.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/unmarshal/AbstractDOMUnmarshaller.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/unmarshal/AbstractDOMUnmarshaller.java	(working copy)
@@ -19,6 +19,7 @@
 import javax.xml.parsers.DocumentBuilderFactory;
 import javax.xml.parsers.ParserConfigurationException;
 
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.w3c.dom.Document;
 import org.w3c.dom.Element;
Index: src/org/jboss/tools/deltacloud/core/StringMatcher.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/StringMatcher.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/StringMatcher.java	(revision 0)
@@ -0,0 +1,65 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core;
+
+import java.util.regex.Matcher;
+import java.util.regex.Pattern;
+import java.util.regex.PatternSyntaxException;
+
+/**
+ * @author Jeff Johnston
+ * @author André Dietisheim
+ */
+public class StringMatcher implements IFieldMatcher {
+
+	private String rule;
+	private Pattern pattern;
+
+	public StringMatcher(String rule) throws PatternSyntaxException {
+		this.rule = rule;
+		String regexRule = transform(rule);
+		pattern = Pattern.compile(regexRule, Pattern.CASE_INSENSITIVE);
+	}
+
+	private String transform(String rule) {
+		StringBuffer buffer = new StringBuffer();
+		for (int i = 0; i < rule.length(); ++i) {
+			char ch = rule.charAt(i);
+			if (Character.isLetterOrDigit(ch))
+				buffer.append(ch);
+			else if (ch == '*') {
+				buffer.append(".*?");
+			} else {
+				buffer.append('\\');
+				buffer.append(ch);
+			}
+		}
+		return buffer.toString();
+	}
+
+	@Override
+	public boolean matches(String input) {
+		if (input == null) {
+			return false;
+		}
+		Matcher m = pattern.matcher(input);
+		return m.matches();
+	}
+
+	@Override
+	public String toString() {
+		return rule;
+	}
+
+	public boolean isMatchesAll() {
+		return false;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/job/LoadCloudImagesJob.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/job/LoadCloudImagesJob.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/job/LoadCloudImagesJob.java	(revision 0)
@@ -0,0 +1,29 @@
+package org.jboss.tools.deltacloud.core.job;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.jboss.tools.deltacloud.core.DeltaCloud;
+
+public class LoadCloudImagesJob extends AbstractCloudElementJob {
+
+	private DeltaCloud cloud;
+	private Runnable post = null;
+	public LoadCloudImagesJob(DeltaCloud cloud) {
+		super("Loading Cloud Images for cloud " + cloud.getName(), 
+				cloud, CLOUDELEMENT.INSTANCES);
+		this.cloud = cloud;
+	}
+	public LoadCloudImagesJob(DeltaCloud cloud, Runnable post) {
+		this(cloud);
+		this.post = post;
+	}
+
+	@Override
+	protected IStatus doRun(IProgressMonitor monitor) throws Exception {
+		cloud.loadImages();
+		if( post != null ) 
+			post.run();
+		return Status.OK_STATUS;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/IFieldMatcher.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/IFieldMatcher.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/IFieldMatcher.java	(working copy)
@@ -16,5 +16,5 @@
 public interface IFieldMatcher {
 	
 	public boolean matches(String input);
-
+	public boolean isMatchesAll();
 }
Index: src/org/jboss/tools/deltacloud/core/client/ResourceAction.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/ResourceAction.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/ResourceAction.java	(revision 0)
@@ -0,0 +1,30 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core.client;
+
+
+/**
+ * @author André Dietisheim
+ */
+public interface ResourceAction<OWNER> {
+
+	public static final String DESTROY = "destroy";
+
+	public String getName();
+
+	public String getUrl();
+
+	public HttpMethod getMethod();
+	
+	public OWNER getOwner();
+
+	public boolean isDestroy();
+}
\ No newline at end of file
Index: src/org/jboss/tools/deltacloud/core/AbstractCloudElementFilter.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/AbstractCloudElementFilter.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/AbstractCloudElementFilter.java	(working copy)
@@ -15,9 +15,6 @@
 import java.util.Collection;
 import java.util.Iterator;
 import java.util.List;
-import java.util.regex.PatternSyntaxException;
-
-import org.eclipse.core.runtime.Assert;
 
 /**
  * @author Jeff Johnston
@@ -30,10 +27,40 @@
 	private IFieldMatcher nameRule;
 	private IFieldMatcher idRule;
 
+
 	public AbstractCloudElementFilter(DeltaCloud cloud) {
+		setRules(new AllMatcher(), new AllMatcher());
+		this.cloud = cloud;
+	}
+
+	public AbstractCloudElementFilter(String nameRule, String idRule, DeltaCloud cloud) {
+		setRules(nameRule, idRule);
+		this.cloud = cloud;
+	}
+
+	public AbstractCloudElementFilter(IFieldMatcher nameRule, IFieldMatcher idRule, DeltaCloud cloud) {
+		setRules(nameRule, idRule);
 		this.cloud = cloud;
 	}
 
+	protected Iterator<String> setRules(String rules) {
+		if (rules == null) {
+			return emptyRulesIterator();
+		}
+		Iterator<String> rulesIterator = Arrays.asList(rules.split(EXPRESSION_DELIMITER)).iterator();
+		setRules(createRule(rulesIterator), createRule(rulesIterator));
+		return rulesIterator;
+	}
+
+	private void setRules(String nameRule, String idRule) {
+		setRules(createRule(nameRule), createRule(idRule));
+	}
+
+	private void setRules(IFieldMatcher nameMatcher, IFieldMatcher idMatcher) {
+		this.nameRule = nameMatcher;
+		this.idRule = idMatcher;
+	}
+
 	public Collection<CLOUDELEMENT> filter(CLOUDELEMENT[] cloudElements) throws DeltaCloudException {
 		List<CLOUDELEMENT> filteredElements = new ArrayList<CLOUDELEMENT>();
 		for (CLOUDELEMENT cloudElement : cloudElements) {
@@ -49,37 +76,29 @@
 				&& idRule.matches(cloudElement.getId());
 	}
 
-	public abstract void setRules(String rulesString) throws PatternSyntaxException;
-
-	protected Iterator<String> setRules(String ruleString, Iterator<String> rulesIterator)
-			throws PatternSyntaxException {
-		this.nameRule = createRule(rulesIterator);
-		this.idRule = createRule(rulesIterator);
-		return rulesIterator;
-	}
-
-	protected Iterator<String> getRulesIterator(String ruleString) {
-		return Arrays.asList(ruleString.split(";")).iterator();
+	protected IFieldMatcher createRule(Iterator<String> rulesIterator) {
+		if (!rulesIterator.hasNext()) {
+			return new AllMatcher();
+		}
+		return createRule(rulesIterator.next());
 	}
 
-	protected IFieldMatcher createRule(Iterator<String> rulesIterator) {
-		Assert.isLegal(rulesIterator.hasNext());
-		String expression = rulesIterator.next();
-		if (expression.equals(ALL_MATCHER_EXPRESSION)) { 
-			return new AllFieldMatcher();
+	protected IFieldMatcher createRule(String rule) {
+		if (rule == null || rule.equals(ALL_MATCHER_EXPRESSION)) {
+			return new AllMatcher();
 		} else {
-			return new FieldMatcher(expression);
+			return new StringMatcher(rule);
 		}
 	}
 
 	protected DeltaCloud getCloud() {
 		return cloud;
 	}
-
+	
 	@Override
 	public String toString() {
-		return nameRule + ";" //$NON-NLS-1$ 
-				+ idRule + ";"; //$NON-NLS-1$
+		return nameRule + EXPRESSION_DELIMITER 
+				+ idRule + EXPRESSION_DELIMITER;
 	}
 
 	@Override
@@ -91,4 +110,14 @@
 	public IFieldMatcher getIdRule() {
 		return idRule;
 	}
+
+	protected Iterator<String> emptyRulesIterator() {
+		return new ArrayList<String>().iterator();
+	}
+
+	public boolean isFiltering() {
+		return !idRule.isMatchesAll()
+		|| !nameRule.isMatchesAll();
+	}
+
 }
Index: src/org/jboss/tools/deltacloud/core/job/InstanceActionJob.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/job/InstanceActionJob.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/job/InstanceActionJob.java	(working copy)
@@ -14,18 +14,18 @@
 import org.eclipse.core.runtime.IStatus;
 import org.eclipse.core.runtime.Status;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
-import org.jboss.tools.deltacloud.core.DeltaCloudInstance.Action;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance.State;
+import org.jboss.tools.deltacloud.core.DeltaCloudResourceAction;
 
 /**
  * @author André Dietisheim
  */
 public class InstanceActionJob extends InstanceStateJob {
 
-	private Action action;
+	private DeltaCloudResourceAction action;
 
 	public InstanceActionJob(String name, DeltaCloudInstance instance, 
-			Action action, State expectedState) {
+			DeltaCloudResourceAction action, State expectedState) {
 		super(name, instance, expectedState);
 		this.action = action;
 	}
@@ -38,7 +38,7 @@
 		return Status.OK_STATUS;
 	}
 
-	protected Action getAction() {
+	protected DeltaCloudResourceAction getAction() {
 		return action;
 	}
 
Index: src/org/jboss/tools/deltacloud/core/job/DestroyCloudInstanceJob.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/job/DestroyCloudInstanceJob.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/job/DestroyCloudInstanceJob.java	(working copy)
@@ -15,6 +15,7 @@
 import org.eclipse.core.runtime.Status;
 import org.eclipse.core.runtime.jobs.ISchedulingRule;
 import org.jboss.tools.deltacloud.core.DeltaCloudInstance;
+import org.jboss.tools.deltacloud.core.DeltaCloudResourceAction;
 
 /**
  * @author André Dietisheim
@@ -22,7 +23,7 @@
 public class DestroyCloudInstanceJob extends InstanceActionJob {
 
 	public DestroyCloudInstanceJob(String name, DeltaCloudInstance instance) {
-		super(name, instance, DeltaCloudInstance.Action.DESTROY, DeltaCloudInstance.State.TERMINATED);
+		super(name, instance, DeltaCloudResourceAction.DESTROY, DeltaCloudInstance.State.TERMINATED);
 	}
 
 	@Override
Index: src/org/jboss/tools/deltacloud/core/client/unmarshal/KeyUnmarshaller.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/unmarshal/KeyUnmarshaller.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/unmarshal/KeyUnmarshaller.java	(working copy)
@@ -14,15 +14,15 @@
 import java.io.IOException;
 import java.io.StringReader;
 
+import org.jboss.tools.deltacloud.core.client.Action;
 import org.jboss.tools.deltacloud.core.client.DeltaCloudClientException;
 import org.jboss.tools.deltacloud.core.client.Key;
-import org.jboss.tools.deltacloud.core.client.KeyAction;
 import org.w3c.dom.Element;
 
 /**
  * @author André Dietisheim
  */
-public class KeyUnmarshaller extends AbstractActionAwareUnmarshaller<Key, KeyAction> {
+public class KeyUnmarshaller extends AbstractActionAwareUnmarshaller<Key> {
 
 	public KeyUnmarshaller() {
 		super("key", Key.class, "link");
@@ -68,9 +68,9 @@
 	}
 
 	@Override
-	protected KeyAction unmarshallAction(Element element) throws DeltaCloudClientException {
-		KeyAction keyAction = new KeyAction();
-		new KeyActionUnmarshaller().unmarshall(element, keyAction);
+	protected Action<Key> unmarshallAction(Element element) throws DeltaCloudClientException {
+		Action<Key> keyAction = new Action<Key>();
+		new ActionUnmarshaller<Key>().unmarshall(element, keyAction);
 		return keyAction;
 	}
 }
Index: src/org/jboss/tools/deltacloud/core/client/unmarshal/ActionUnmarshaller.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/unmarshal/ActionUnmarshaller.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/unmarshal/ActionUnmarshaller.java	(revision 0)
@@ -0,0 +1,35 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+package org.jboss.tools.deltacloud.core.client.unmarshal;
+
+import org.jboss.tools.deltacloud.core.client.Action;
+import org.w3c.dom.Element;
+
+/**
+ * @author André Dietisheim
+ */
+public class ActionUnmarshaller<OWNER> extends AbstractDOMUnmarshaller<Action<OWNER>> {
+
+	@SuppressWarnings({ "unchecked", "rawtypes" })
+	public ActionUnmarshaller() {
+		super("link", (Class) Action.class);
+	}
+
+	@Override
+	protected Action<OWNER> doUnmarshall(Element element, Action<OWNER> action) throws Exception {
+		if (element != null) {
+			action.setMethod(getAttributeText("method", element));
+			action.setName(getAttributeText("rel", element));
+			action.setUrl(getAttributeText("href", element));
+		}
+		return action;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/client/ActionAware.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/ActionAware.java	(revision 0)
+++ src/org/jboss/tools/deltacloud/core/client/ActionAware.java	(revision 0)
@@ -0,0 +1,84 @@
+/*******************************************************************************
+ * Copyright (c) 2010 Red Hat Inc..
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat Incorporated - initial API and implementation
+ *******************************************************************************/
+package org.jboss.tools.deltacloud.core.client;
+
+import java.util.ArrayList;
+import java.util.List;
+
+/**
+ * @author Martyn Taylor
+ * @author André Dietisheim
+ */
+public abstract class ActionAware<OWNER> extends IdAware {
+
+	private List<Action<OWNER>> actions;
+
+	public Action<OWNER> getAction(String name) {
+		if (name == null) {
+			return null;
+		}
+
+		for (Action<OWNER> action : getActions()) {
+			if (name.equals(action.getName())) {
+				return action;
+			}
+		}
+		return null;
+	}
+
+	public List<String> getActionNames() {
+		ArrayList<String> names = new ArrayList<String>();
+		for (Action<OWNER> action : getActions()) {
+			names.add(action.getName());
+		}
+		return names;
+	}
+
+	public boolean start(DeltaCloudClient client) throws DeltaCloudClientException {
+		return client.performAction(getAction(Action.START_NAME));
+	}
+
+	public boolean stop(DeltaCloudClient client) throws DeltaCloudClientException {
+		return client.performAction(getAction(Action.STOP_NAME));
+	}
+
+	public boolean destroy(DeltaCloudClient client) throws DeltaCloudClientException {
+		return client.performAction(getAction(Action.DESTROY_NAME));
+	}
+
+	public boolean reboot(DeltaCloudClient client) throws DeltaCloudClientException {
+		return client.performAction(getAction(Action.REBOOT_NAME));
+	}
+
+	public boolean canStart() {
+		return getAction(Action.START_NAME) != null;
+	}
+
+	public boolean canStop() {
+		return getAction(Action.STOP_NAME) != null;
+	}
+
+	public boolean canReboot() {
+		return getAction(Action.REBOOT_NAME) != null;
+	}
+
+	public boolean canDestroy() {
+		return getAction(Action.DESTROY_NAME) != null;
+	}
+
+	public void setActions(List<Action<OWNER>> actions) {
+		this.actions = actions;
+	}
+
+	public List<Action<OWNER>> getActions() {
+		return actions;
+	}
+}
Index: src/org/jboss/tools/deltacloud/core/client/HardwareProfile.java
===================================================================
--- src/org/jboss/tools/deltacloud/core/client/HardwareProfile.java	(revision 29286)
+++ src/org/jboss/tools/deltacloud/core/client/HardwareProfile.java	(working copy)
@@ -19,7 +19,7 @@
  * @author Martyn Taylor
  * @author André Dietisheim
  */
-public class HardwareProfile extends AbstractDeltaCloudObject {
+public class HardwareProfile extends IdAware {
 	private static final long serialVersionUID = 1L;
 
 	private List<Property> properties;
